<style lang="scss">
  #commit-list {
    #repo-identifier, #branches {
      width: 30%;
    }

    #search {
      transform: translateY(8px);

      &.hint span {
        animation: opacity 1.5s ease-in-out infinite;

        @keyframes opacity {
          0% { opacity: 1; }
          50% { opacity: 0.5; }
          100% { opacity: 1; }
        }
      }
    }

    #from-date, #to-date {
      width: 12%;
    }

    @media screen and (max-width: 920px) {
      #repo-identifier {
        width: 100%;
      }

      #from-date, #to-date {
        width: 40%;
      }
    }
  }
</style>

<template>
  <div class="card-padding" id="commit-list">
    <div class="layout-padding row items-center justify-between wrap">
      <q-input v-model="repoIdentifier" float-label="GitHub Repo, type three characters to search github"
               id="repo-identifier" @click="triggerAutocomplete">
        <q-autocomplete  @search="searchForRepositories" :min-characters="0" @selected="updateRepoBranches"
                         :debounce="500" :max-results="Number.POSITIVE_INFINITY" ref="autocomplete"/>
      </q-input>

      <q-select v-model="selectedBranch" @change="cleanQuery" :options="branches" id="branches" float-label="Branch"/>

      <q-datetime v-model="fromDate" type="date" float-label="Filter from" id="from-date" format="DD.MM.YY"/>
      <q-datetime v-model="toDate" type="date" float-label="to a date" id="to-date" format="DD.MM.YY"/>

      <q-btn icon="search" id="search" flat round @click="getCommits" v-bind:class="{ hint: !commits.length }"></q-btn>
    </div>

    <q-infinite-scroll :handler="getCommits">
      <commit-list-item v-for="commit in commits" v-bind:commit="commit" :key="commit.sha"></commit-list-item>
      <div class="column items-center" v-if="commits.length">
        <q-spinner-dots slot="message" :size="40"></q-spinner-dots>
      </div>
    </q-infinite-scroll>
  </div>
</template>

<script>
import { QBtn, QCard, QCardMain, QInput, QDatetime, QInfiniteScroll, QSpinnerDots, QCardTitle, QAutocomplete, QSelect } from 'quasar';
import CommitService from './CommitService';
import PastReposService from './PastReposService';
import CommitListItem from './CommitListItem.vue';

export default {
  data() {
    return {
      terms: '',
      repoFromPast: '',
      repoIdentifier: '',
      fromDate: '',
      toDate: '',
      commits: [],
      pastRepos: [],
      branches: [],
      selectedBranch: null,
      repositorySearchResults: [],
      latestFetchedToDate: null,
    };
  },
  methods: {
    triggerAutocomplete() {
      if (!this.repoIdentifier) {
        this.$refs.autocomplete.trigger();
      }
    },
    updateQuery() {
      this.$router.replace({
        query: {
          repo: this.repoIdentifier,
          from: Date.parse(this.fromDate),
          to: Date.parse(this.toDate),
        },
      });
    },
    cleanQuery() {
      this.latestFetchedToDate = null;
      this.commits = [];
    },
    getBranches() {
      CommitService.setRepository(this.repoIdentifier);
      CommitService.listBranches().then((branches) => {
        this.branches = branches.map(branch => ({ label: branch.name, value: branch.name }));
      });
    },
    setDateOneDaysIntoThePast() {
      const currentToDate = new Date(this.toDate);
      this.toDate = new Date(currentToDate.getFullYear(), currentToDate.getMonth(), (currentToDate.getDate() - 1));
    },
    doCommitsExist() {
      return this.commits.length;
    },
    setRepoFromPast(repo) {
      this.repoIdentifier = repo;
    },
    updatePastRepos() {
      this.pastRepos = PastReposService.getPastRepos().map(repo => ({ value: repo, label: repo }));
    },
    getCommits(index, done) {
      this.setDateOneDaysIntoThePast();

      if (this.fromDate && this.toDate && this.repoIdentifier) {
        PastReposService.addRepo(this.repoIdentifier);
        this.updatePastRepos();

        CommitService.setRepository(this.repoIdentifier);
        CommitService.getCommits(this.selectedBranch, this.latestFetchedToDate || this.fromDate, this.toDate)
          .then(commitWrappers => this.updateCommitsAndQuery(commitWrappers, done))
          .catch(errors => this.$q.notify.create(errors.toString()));
      }
    },
    updateCommitsAndQuery(commitWrappers, done) {
      this.getCommitsBySHA(commitWrappers, done);
      this.updateQuery();
    },
    getCommitsBySHA(commitWrappers, done) {
      const commitPromises = commitWrappers.map(commitWrapper => CommitService.getCommit(commitWrapper.sha));
      Promise.all(commitPromises)
        .then(commits => this.postFetchProcessing(commits, done))
        .catch(errors => this.$q.notify((errors.toString())));
    },
    postFetchProcessing(commits, done) {
      this.commits.push(...commits);
      this.latestFetchedToDate = this.toDate;

      if (!this.doCommitsExist()) {
        this.getCommits();
      }

      if (done && typeof done === 'function') {
        done();
      }
    },
    getInitialRepo() {
      this.repoIdentifier = this.$route.query.repo || CommitService.loadLatestRepo();
    },
    setInitialDates() {
      this.fromDate = new Date(parseInt(this.$route.query.from, 10) || new Date());
      this.toDate = new Date(parseInt(this.$route.query.to, 10) || new Date().setDate(this.fromDate.getDate() - 1));
    },
    setDefaultBranch() {
      CommitService.setRepository(this.repoIdentifier);
      return CommitService.getRepositoryDetails().then(repository => this.selectedBranch = repository.default_branch);
    },
    searchForRepositories(terms, done) {
      if (terms.length > 2) {
        CommitService.searchRepository({ q: `${terms} in:name` })
          .then((response) => {
            const searchResultRepos = response.map(repo => ({ label: repo.full_name, value: repo.full_name }));
            done(searchResultRepos);
          });
      } else {
        done(this.pastRepos);
      }
    },
    updateRepoBranches() {
      this.cleanQuery();
      return this.setDefaultBranch().then(this.getBranches);
    },
  },
  mounted() {
    this.updatePastRepos();
    this.getInitialRepo();
    this.setInitialDates();
    this.updateRepoBranches();
  },
  components: {
    QBtn,
    QCard,
    QDatetime,
    QCardMain,
    QInput,
    QInfiniteScroll,
    QSpinnerDots,
    QCardTitle,
    CommitListItem,
    QAutocomplete,
    QSelect,
  },
};
</script>
